PARAMETERS m.SpecFiles
_SCREEN.WINDOWSTATE = 2
_SCREEN.AUTOCENTER = .T.
_SCREEN.BACKCOLOR = RGB(0,0,255)
_SCREEN.CAPTION="Browser"
_SCREEN.VISIBLE =.T.
SET DATE BRITISH
SET EXCLUSIVE OFF


m.INHIBITDAYS = "SAT,SUN,"
m.INHIBITHOLS	= .T.

IF PCOUNT() < 1
	m.SpecFiles = "*.dbf"
ENDIF

m.TableCount = ADIR(gblTableList,m.SpecFiles)
m.IndexName = ""
IF m.TableCount > 0 
	m.TableName = ""
	DO FORM SelTable
	IF !EMPTY(m.TableName)
		SELECT 0
		USE (m.TableName)
		GO top
		IF MyFile(JUSTSTEM(m.TableName)+".cdx")
			m.IndexCount = ATAGINFO(gblIndexBase)
			IF m.IndexCount > 0
				DECLARE gblIndexList(m.IndexCount,2)
				FOR i = 1 TO m.IndexCount
					gblIndexList(i,1) = gblIndexbase(i,1)
					gblIndexList(i,2) = gblIndexbase(i,3)
				Next
				m.IndexName = ""
				DO FORM SelIndex
				IF !EMPTY(m.IndexName)
					SET ORDER TO (m.IndexName)
				EndIF
			EndIF
		ENDIF
		DO FORM selposition
		BROWSE
	ENDIF

ELSE
	MESSAGEBOX("No Tables Found",48,"Problem")
ENDIF

FUNCTION GETDATE
	PARAMETERS m.DATE,m.NUMDAYS
	PRIVATE m.DATE,m.NUMDAYS
	PRIVATE OLDAREA, I, m.CLOSEF
	OLDAREA = SELECT()
	m.CLOSEF = .F.
	m.datalocation = ".\"
	IF TYPE("POPHOL.HDATE") = "U"
		SELECT 0
		USE  (m.DATALOCATION+"POPHOL")
		m.CLOSEF = .T.
	ENDIF
	IF !EMPTY(m.DATE)
		IF m.NUMDAYS > 0
			I = 0
			DO WHILE I < m.NUMDAYS
				m.DATE = m.DATE + 1
				IF m.INHIBITHOLS
					SELECT POPHOL
					SET ORDER TO POPHOL
					SEEK DTOS(m.DATE)
					IF !FOUND() .AND. !LEFT(UPPER(CDOW(m.DATE)),3)$m.INHIBITDAYS
						I = I +1
					ENDIF
				ELSE
					I = I +1
				ENDIF
			ENDDO
		ELSE
			I = 0
			DO WHILE I < (-1 * m.NUMDAYS)
				m.DATE = m.DATE - 1
				IF m.INHIBITHOLS
					SELECT POPHOL
					SET ORDER TO POPHOL
					SEEK DTOS(m.DATE)
					IF !FOUND() .AND. !LEFT(UPPER(CDOW(m.DATE)),3)$m.INHIBITDAYS
						I = I +1
					ENDIF
				ELSE
					I = I +1
				ENDIF
			ENDDO
		ENDIF
	ENDIF
	IF m.CLOSEF
		SELECT POPHOL
		USE
	ENDIF
	SELECT(OLDAREA)
	RETURN(m.DATE)


FUNCTION MyProg
parameters mfilename,morder,mfilter,MDOSUMMAT

set exclusive off
set date british
set deleted off

use (mfilename)
if pcount() > 1
	if morder <> "none"
		set order to (morder)
	EndIf
endif
if pcount() > 2
	set filter to &mfilter
endif
IF PCOUNT() > 3
	&MDOSUMMAT
ENDIF
go top
browse
Return(.t.)	

FUNCTION MYFILE
	PARAMETER m.FILENAME
	PRIVATE m.FILENAME,m.FLG
	m.FLG = .F.
	IF !EMPTY(m.FILENAME)
		IF ADIR(TMPDIRFILES,m.FILENAME) > 0
			m.FLG = .T.
		ENDIF
	ENDIF
	RETURN(m.FLG)
	
FUNCTION UNCODETEXT
	PARAMETERS m.STRING
	PRIVATE m.STRING
	m.STRING = STRTRAN(m.STRING,"%/C%",CHR(13))
	m.STRING = STRTRAN(m.STRING,"%/N%",CHR(10))
	m.STRING = STRTRAN(m.STRING,"%/L%",CHR(39))
	m.STRING = STRTRAN(m.STRING,"%/Q%",CHR(34))
	m.STRING = STRTRAN(m.STRING,"%/c%",CHR(13))
	m.STRING = STRTRAN(m.STRING,"%/n%",CHR(10))
	m.STRING = STRTRAN(m.STRING,"%/l%",CHR(39))
	m.STRING = STRTRAN(m.STRING,"%/q%",CHR(34))
	RETURN(m.STRING)
	

FUNCTION UNISSUED
	PRIVATE M.FLAG,M.KEY, M.OLDAREA, M.OLDORDER, M.OLDRECNO
	m.OLDAREA = SELECT(0)
	
	M.KEY = MADEBY+CLIENTDRG+REVNO
	IF TYPE("IV.ISSUED") <> "L"
		SELECT 0
		USE POPIV AGAIN ALIAS IV
	ENDIF		
	SELECT IV
	m.OLDRECNO = RECNO()
	m.OLDORD	= ORDER()
	SET ORDER TO POPIV4
	** madeby+clientdrg+revno
	SEEK (M.KEY)
	IF FOUND()
		M.FLAG = ISSUED
	ELSE
		M.FLAG = .T.
	ENDIF
	
	SET ORDER TO (m.OLDORD)
	IF m.OLDRECNO > 0 .AND. m.OLDRECNO <= RECCOUNT()
		GOTO m.OLDRECNO
	ENDIF
	SELECT (m.OLDAREA)
RETURN(!M.FLAG)
	
FUNCTION EMPTYPLAN
	PRIVATE M.FLAG,M.KEY, M.OLDAREA, M.OLDORDER, M.OLDRECNO
	m.OLDAREA = SELECT(0)
	
	M.KEY = MADEBY+CLIENTDRG
	M.FLAG = .F.
	IF !EMPTY(POPIN.PLANNED) .OR. !EMPTY(POPIN.FORECAST)
		IF TYPE("IV.ISSUED") <> "L"
			SELECT 0
			USE POPIV AGAIN ALIAS IV
		ENDIF		
		SELECT IV
		m.OLDRECNO = RECNO()
		m.OLDORD	= ORDER()
		SET ORDER TO POPIV4
		** madeby+clientdrg+revno
		SEEK (M.KEY)
		IF FOUND()
			M.FLAG = .F.
		ELSE
			M.FLAG = .T.
		ENDIF
		
		SET ORDER TO (m.OLDORD)
		IF m.OLDRECNO > 0 .AND. m.OLDRECNO <= RECCOUNT()
			GOTO m.OLDRECNO
		ENDIF
		SELECT (m.OLDAREA)
	ENDIF
RETURN(M.FLAG)
	